// -----------------
// CubicSpline.h
// Jason Hughes
// Origin Systems
// Copyright 1998
// -----------------

#ifndef CUBICSPLINE_H
#define CUBICSPLINE_H

class CubicSpline
{
protected:
	int  numSamples;
	real *T,*Y,*Z;                   // goddamn fortran programmers.  What the hell are these?

	void triSolve(int samples,const real *A,real *D,const real *C,real *B) const;

public:
	struct Sample
	{
		real x;
		real y;
	};

	// -----------------

	CubicSpline(void);
	~CubicSpline(void);

	void setSamples(int sampleCount,const Sample *sampleArray);
	real getSample(real x) const;
};

#endif
